=== debian/changelog ===
hydrasdr-host (1.1.0-1) experimental; urgency=medium

  * New upstream release
  * New upstream repository -> new source package name.
  * Library soversion bump -> new library package name
    upload to experimental.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 07 Feb 2026 21:15:44 -0500

rfone-host (1.0.3-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 20 Oct 2025 22:49:03 -0400

rfone-host (1.0.2-1) experimental; urgency=medium

  * New package (Closes: 1111685)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 13 Oct 2025 20:28:53 -0400
