=== debian/control ===
Source: hydrasdr-host
Section: comm
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libusb-1.0-0-dev,
               pkgconf
Standards-Version: 4.7.3
Rules-Requires-Root: no
Homepage: https://hydrasdr.com
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/hydrasdr-host
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/hydrasdr-host.git

Package: hydrasdr-tools
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, libhydrasdr1 (= ${binary:Version}), ${misc:Depends}
Description: HydraSDR RFOne software defined radio receiver - user runtime
 HydraSDR RFOne is an open source Software Defined Radio that can
 receive 24-1850 MHz.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains some utility applications.
  * hydrasdr_gpio
  * hydrasdr_lib_version
  * hydrasdr_info: probe device and show configuration
  * hydrasdr_rx
  * hydrasdr_calibrate

Package: libhydrasdr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libhydrasdr1 (= ${binary:Version}), ${misc:Depends}
Description: HydraSDR RFOne software defined radio receiver - development
 HydraSDR RFOne is an open source Software Defined Radio that can
 receive 24-1850 MHz.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains development files.

Package: libhydrasdr1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: HydraSDR RFOne software defined radio receiver - library
 HydraSDR RFOne is an open source Software Defined Radio that can
 receive 24-1850 MHz.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains the shared library.
