=== debian/watch ===
Version: 5

Template: Github
Owner: hydrasdr
Project: hydrasdr-host
Update-Script: uupdate
